/*----------------------------------------------------------
*                                      
*    __  __                      
*   | | / /__  __ _____    ___    __   _____  ___
*   |  / / \ \/ //     \  /   \ /`__'\|  __| /   \
*   |  \ \  \  // /| |\ \|  O  |  ___/| |  `|  O  | 
*   |_| \_\  |_|_/ |_| \_\\_/|_|\___\ |_|    \_/|_|
*                  
*
*   Kymaera (c) 2004 
*	Universal Arcade Cabinet Front End
*
*	Steve Hernandez: steveh@crosslink.net 
*   Windows, Linux and Dos version
*   See the Readme.txt and License.txt for more information          
*
*
* -----------------------------------------------------------
*/

#ifndef FILEUTILS
#define FILEUTILS
#include "stdio.h"
#include "listitem.h"
#include <string>
using namespace std;
void ToUpper(std::string *str);


void GetFilePath(char *filen,char *retpath);
void GetFileName(char *filen,char *retname);
void GetFileBase(char *infile,char *retfile);
void GetFileTitle(char *filen,char *retname);
void GetExtension(const char *srcfile,char *outext);
void FixPath(char *pathname);
void FileCopy(char *filen,char *fileout);
long GetFileLength(char *name );
long GetFileLength(FILE *file );
bool FileExists(char *f);
void ChangeExtension(char *in,char *newext,char *out);
bool MatchString(char *s1,char *s2); // case insensitive(lcase)
void LoadString(string *str,FILE *fp);
void SaveString (string str,FILE *fp);
void SaveStringList(List *lst,FILE *fp);
void LoadStringList(List *lst,FILE *fp);
void SetBasePath(string pth);
string RelativePath(string pathin);
string RelativeFile(string pathin);
void ExistOrDie(string filename,string message);
void GetDirListing(string dir,List *dirlist);
string FileDateTime(string filename);
void UserMessage(string s,bool fatal = true);
class GameEntry;
bool HasExtension(char *filename);
void RemoveExtension(char *filein, char *fileout);
#endif
