/*----------------------------------------------------------
*                                      
*    __  __                      
*   | | / /__  __ _____    ___    __   _____  ___
*   |  / / \ \/ //     \  /   \ /`__'\|  __| /   \
*   |  \ \  \  // /| |\ \|  O  |  ___/| |  `|  O  | 
*   |_| \_\  |_|_/ |_| \_\\_/|_|\___\ |_|    \_/|_|
*                  
*
*   Kymaera (c) 2004 
*	Universal Arcade Cabinet Front End
*
*	Steve Hernandez: steveh@crosslink.net 
*   Windows, Linux and Dos version
*   See the Readme.txt and License.txt for more information          
*
*
* -----------------------------------------------------------
*/

#ifndef MMDD
#define MMDD
#include "allegro.h"
#include "singleton.h"
#include "kyrect.h"
// A Screen represents one display that images can be drawn to.
// I'm making it a singleton for now, this may change with
// multimonitor support
extern double SIN_TABLE[360];
extern double COS_TABLE[360];
class Screen : public Singleton <Screen>
{
public:
	bool				 m_fullscreen; // are we full screen?
	int					 m_bpp;// bits per pixel of screen
	int					 m_width,m_height;
	long				framecount;
	BITMAP				 *backbuffer;
	KYRect				 rcfullscreen; // the size of the frontbuffer
	KYRect				 rcbackbuff;// the size of the back buffer
	KYRect				 rcBackRenderPos;/* if we are not in full screen mode, (editor - window mode)
							this is the rc where we draw the backbuffer 
							onto the front buffer
							*/
	~Screen();
	Screen();
	void Initialize(int scr_width,int scr_height,int bpp,int skn_width,int skn_height,bool windowed);
	void StretchBackToFullScreen();
	void PageFlip();
	void Cleanup(bool final);
	void Pause();
	void Resume();
	void InitGlobalPallete();
	void ClsBack(long color){
	   clear_bitmap(backbuffer);
	}/// clear the back buffer in ddraw
	BITMAP * KYLoadMedia(char * szBitmap);

};


#define TheScreen Screen::GetInstance()

#endif 

