/*----------------------------------------------------------
*                                      
*    __  __                      
*   | | / /__  __ _____    ___    __   _____  ___
*   |  / / \ \/ //     \  /   \ /`__'\|  __| /   \
*   |  \ \  \  // /| |\ \|  O  |  ___/| |  `|  O  | 
*   |_| \_\  |_|_/ |_| \_\\_/|_|\___\ |_|    \_/|_|
*                  
*
*   Kymaera (c) 2004 
*	Universal Arcade Cabinet Front End
*
*	Steve Hernandez: steveh@crosslink.net 
*   Windows, Linux and Dos version
*   See the Readme.txt and License.txt for more information          
*
*
* -----------------------------------------------------------
*/

#ifndef Singleton_H
#define Singleton_H

template< class T > class Singleton
{
public:
	inline static T *GetInstance() ;
	static void DestroyInstance() ;
//	inline static bool HasInstance() ;
protected:
	Singleton() ;
	~Singleton() ;
private:
	static T *s_pInstance ;
	static bool s_bAddedToAtExit ;

} ;

template< class T > 
T * Singleton< T >::GetInstance()
{
	if( s_pInstance == 0 )
	{
		s_pInstance = new T ;

		if( ! s_bAddedToAtExit )
		{
			atexit( DestroyInstance ) ;
			s_bAddedToAtExit = true ;
		}

	}

	return s_pInstance ;

}

template< class T >
void Singleton< T >::DestroyInstance()
{
	if(s_pInstance){
		delete s_pInstance;
		s_pInstance = 0;
	}
}

template< class T >
Singleton< T >::Singleton()
{
}

template< class T >
Singleton< T >::~Singleton()
{
	s_pInstance = 0 ;
}

template< class T >
T *Singleton<T>::s_pInstance ;

template< class T >
bool Singleton<T>::s_bAddedToAtExit ;


#endif  

