/*----------------------------------------------------------
*                                      
*    __  __                      
*   | | / /__  __ _____    ___    __   _____  ___
*   |  / / \ \/ //     \  /   \ /`__'\|  __| /   \
*   |  \ \  \  // /| |\ \|  O  |  ___/| |  `|  O  | 
*   |_| \_\  |_|_/ |_| \_\\_/|_|\___\ |_|    \_/|_|
*                  
*
*   Kymaera (c) 2004 
*	Universal Arcade Cabinet Front End
*
*	Steve Hernandez: steveh@crosslink.net 
*   Windows, Linux and Dos version
*   See the Readme.txt and License.txt for more information          
*
*
* -----------------------------------------------------------
*/
#include "texturemgr.h"
#include "crc.h"
TextureMgr::TextureMgr(void)
{
}
void TextureMgr::RemoveRef(BITMAP * pSurf){
	TextureItem *ti;
//	unsigned long cnt;
	for (Listitem *li = m_TextItems.list;li!=0;li=li->next){
		ti =(TextureItem *)li->data;
		if(ti->pSurf == pSurf){
			ti->m_refcount --;
//			cnt = pdds->Release();
			if(ti->m_refcount == 1){
//				pdds->Release();
				destroy_bitmap(pSurf);
				m_TextItems.Remove(ti);
				delete ti;
				return;
			}
		}
		
	}
	//if it's not in out list,  release it anyways
//	pdds->Release();
}
TextureMgr::~TextureMgr(void)
{
	TextureItem *ti;
	for (Listitem *li = m_TextItems.list;li!=0;li=li->next){
		ti =(TextureItem *)li->data;
		delete ti;
	}
	m_TextItems.Destroy();
}

BITMAP * TextureMgr::Find(char *name){
	unsigned long crc = g_CRC32.Calcistr(name);
	TextureItem *ti;
	for (Listitem *li = m_TextItems.list;li!=0;li=li->next){
		ti =(TextureItem *)li->data;
		if(ti->m_nameCRC == crc)
		{
			ti->m_refcount ++;
			return ti->pSurf;
		}
	}
	return 0;
}

